package com.example.mylog;




import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;

public class DBAdapter {

    public static final String KEY_ROWID = "_id";

       public static final String KEY_DATE = "Date";
       public static final String KEY_TIME = "Time";
       public static final String KEY_NAME = "Name";
       public static final String KEY_PHONENUMBER = "Phonenumber";
       public static final String KEY_DURATION = "Duration";
       public static final String KEY_CALLCLASSIFICATION = "CallClassification";
       private static final String TAG = "DBAdapter";
       
       private static final String DATABASE_NAME = "userdata";
       private static final String DATABASE_TABLE = "PhoneLogs";
       private static final int DATABASE_VERSION = 2;

       private static final String DATABASE_CREATE =
    	   "create table "+DATABASE_TABLE+" (_id integer primary key autoincrement, "
           + "Date text not null, Time text not null, Name text not null, " 
           + "Phonenumber text not null, Duration text not null, CallClassification text not null);";
       
       
           
           
           
       private final Context context;  

       private DatabaseHelper DBHelper;
       private SQLiteDatabase db;

       public DBAdapter(Context ctx) 
       {
           this.context = ctx;
           DBHelper = new DatabaseHelper(context);
       }
           
       private static class DatabaseHelper extends SQLiteOpenHelper 
       {
           DatabaseHelper(Context context) 
           {
               super(context, DATABASE_NAME, null, DATABASE_VERSION);
           }

           @Override
           public void onCreate(SQLiteDatabase db) 
           {
               db.execSQL(DATABASE_CREATE);
           }

           @Override
           public void onUpgrade(SQLiteDatabase db, int oldVersion, 
                                 int newVersion) 
           {
               Log.w(TAG, "Upgrading database from version " + oldVersion 
                     + " to "
                     + newVersion + ", which will destroy all old data");
               db.execSQL("DROP TABLE IF EXISTS titles");
               onCreate(db);
           }
       }    

       //---opens the database---
       public DBAdapter open() throws SQLException 
       {
           db = DBHelper.getWritableDatabase();
           return this;
       }

       //---closes the database---    
       public void close() 
       {
           DBHelper.close();
       }
       
       //---insert a new call log into the database---
       public long insertCallLogs(String date, String time, String name, String number, String duration, String classification) 
       {
           ContentValues initialValues = new ContentValues();
           initialValues.put(KEY_DATE, date);
           initialValues.put(KEY_TIME, time);
           initialValues.put(KEY_NAME, name);
           initialValues.put(KEY_PHONENUMBER, number);
           initialValues.put(KEY_DURATION, duration);
           initialValues.put(KEY_CALLCLASSIFICATION, classification);           
           
           return db.insert(DATABASE_TABLE, null, initialValues);
       }
       

       //---retrieves all the LOGS---
       public Cursor getAllCallLogs() 
       {
           return db.query(DATABASE_TABLE, new String[] {
                 KEY_ROWID,
                 KEY_DATE,
                 KEY_TIME,
                 KEY_NAME,
                 KEY_PHONENUMBER,
                 KEY_DURATION,
                 KEY_CALLCLASSIFICATION
                   }, 
                   null, 
                   null, 
                   null, 
                   null, 
                   null,
                   null);
       }
       


       
       
}