package com.example.mylog;


import android.app.Activity;
import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.SystemClock;
import android.telephony.TelephonyManager;
import android.util.Log;


public class PhoneServiceReceiver extends BroadcastReceiver {
	
	private static final String TAG = PhoneServiceReceiver.class.getSimpleName();

	boolean prefPhone = true;
	
	@Override
	public void onReceive(Context context, Intent intent) 
	{

        String state = intent.getStringExtra(TelephonyManager.EXTRA_STATE);

        if (state != null && state.equals(TelephonyManager.EXTRA_STATE_IDLE)) {
        	Log.d(TAG, "State is IDLE");

            // Here comes the actual Service-Functionality
            
            Intent pService = new Intent();
            pService.setAction("com.example.mylog.PhoneService");

            int sleep = 5000; // Waiting time before Log-database is accessed
            
            PendingIntent piSync = PendingIntent.getService(context, 0, pService, 0);
            Log.i(TAG, "schedulePendingSync: " + piSync.toString());
            AlarmManager alarm = (AlarmManager) context.getSystemService(Activity.ALARM_SERVICE);
            alarm.set(AlarmManager.ELAPSED_REALTIME, SystemClock.elapsedRealtime() + sleep, piSync);

            // End of Service-Functionality
        
        }


		
	}
	
}